from .Model import WINDOWS_MODLUE
from .const import (
    PROCESS_ALL_ACCESS, 
    TH32CS_SNAPMODULE
)
from .Structure import MODULEENTRY32
import ctypes as _ctypes

initModule = WINDOWS_MODLUE()
class SetupPro32(object):
    def __init__(self, pid) -> None:
        self.ProcessId = pid
        self.hProcess = initModule.OpenProcess(PROCESS_ALL_ACCESS, 0, self.ProcessId)
    
    def GetBaseAddr32(self, moduleName):
        '''
        :func: 用于取32位应用程序模块地址
        :param ModuleName: 模块名称 如: dll、exe
        :return: 十六进制 整数
        '''
        mod32 = MODULEENTRY32()
        mod32.dwSize = _ctypes.sizeof(MODULEENTRY32)
        hModuleSnap = initModule.CreateToolhelp32(TH32CS_SNAPMODULE[0], self.ProcessId)
        while 0 != 1:
            initModule.Module32Next(hModuleSnap, _ctypes.pointer(mod32))
            if mod32.szModule.decode("gbk") == moduleName:
                initModule.CloseHandle(hModuleSnap)
                return mod32.modBaseAddr
  
    def ReadMemory32(self, addr, size=4):
        '''
        :func: 用于读32位应用程序
        :param addr: 内存地址
        :param size: 类型大小可调节
        :return: 十六进制 整数
        '''
        addr = _ctypes.c_int(addr)
        retn = _ctypes.c_int()
        BufferLength = _ctypes.c_int32(size)
        initModule.ReadProcessMemory(int(self.hProcess), addr, _ctypes.byref(retn), BufferLength, 0)
        return retn.value

    def ReadMemory32_float(self, addr, size=4):
        addr = _ctypes.c_int(addr)
        retn = _ctypes.c_float()
        BufferLength = _ctypes.c_int(size)
        initModule.ReadProcessMemory(int(self.hProcess), addr, _ctypes.byref(retn), BufferLength, 0)
        return retn.value

    def ReadMemory32_double(self, addr, size=8):
        addr = _ctypes.c_int(addr)
        retn = _ctypes.c_double()
        BufferLength = _ctypes.c_int(size)
        initModule.ReadProcessMemory(int(self.hProcess), addr, _ctypes.byref(retn), BufferLength, 0)
        return retn.value

    def ReadMemory32_byte(self, addr, size=1):
        addr = _ctypes.c_int(addr)
        retn = _ctypes.c_byte()
        BufferLength = _ctypes.c_int(size)
        initModule.ReadProcessMemory(int(self.hProcess), addr, _ctypes.byref(retn), BufferLength, 0)
        return retn.value

    def WriteMemory32(self, addr, var, size=4):
        '''
        :func: 用于写32位应用程序
        :param addr: 内存地址
        :param var: 写入的数值
        :param size: 类型大小可调节
        :return: 整数
        '''
        addr = _ctypes.c_int(addr)
        retn = _ctypes.c_int(var)
        BufferLength = _ctypes.c_int(size)
        initModule.WriteProcessMemory(int(self.hProcess), addr, _ctypes.byref(retn), BufferLength, 0)

    def WriteMemory32(self, addr, var, size=4):
        addr = _ctypes.c_int(addr)
        retn = _ctypes.c_int(var)
        BufferLength = _ctypes.c_int(size)
        return initModule.WriteProcessMemory(int(self.hProcess), addr, _ctypes.byref(retn), BufferLength, 0)


    def WriteMemory32_float(self, addr, var, size=4):
        addr = _ctypes.c_int(addr)
        retn = _ctypes.c_float(var)
        BufferLength = _ctypes.c_int(size)
        return initModule.WriteProcessMemory(int(self.hProcess), addr, _ctypes.byref(retn), BufferLength, 0)


    def WriteMemory32_double(self, addr,var, size=8):
        addr = _ctypes.c_int(addr)
        retn = _ctypes.c_double(var)
        BufferLength = _ctypes.c_int(size)
        return initModule.WriteProcessMemory(int(self.hProcess), addr, _ctypes.byref(retn), BufferLength, 0)


    def WriteMemory32_byte(self,addr,var, size=1):
        addr = _ctypes.c_int(addr)
        retn = _ctypes.c_byte(var)
        BufferLength = _ctypes.c_int(size)
        return initModule.WriteProcessMemory(int(self.hProcess), addr, _ctypes.byref(retn), BufferLength, 0)