from .Model import WINDOWS_MODLUE
from .const import PROCESS_ALL_ACCESS
from .Structure import PROCESS_BASIC_INFORMATION
import ctypes as _ctypes

initModule = WINDOWS_MODLUE()
class SetupPro64(object):
    def __init__(self, pid) -> None:
        self.ntdll = _ctypes.WinDLL("ntdll.dll")
        self.hProcess = initModule.OpenProcess(PROCESS_ALL_ACCESS, 0, pid)

    def ReadMemory64(self, addr, size=4):
        addr = _ctypes.c_ulonglong(addr)
        retn = _ctypes.c_ulonglong()
        BufferLength = _ctypes.c_ulonglong(size)
        self.ntdll.NtWow64ReadVirtualMemory64(int(self.hProcess), addr, _ctypes.byref(retn), BufferLength, 0)
        return retn.value

    def ReadMemory64_float(self,addr, size=4):
        addr = _ctypes.c_ulonglong(addr)
        retn = _ctypes.c_float()
        BufferLength = _ctypes.c_ulonglong(size)
        self.ntdll.NtWow64ReadVirtualMemory64(int(self.hProcess), addr, _ctypes.byref(retn), BufferLength, 0)
        return retn.value

    def ReadMemory64_double(self, addr, size=8):
        addr = _ctypes.c_ulonglong(addr)
        retn = _ctypes.c_double()
        BufferLength = _ctypes.c_ulonglong(size)
        self.ntdll.NtWow64ReadVirtualMemory64(int(self.hProcess), addr, _ctypes.byref(retn), BufferLength, 0)
        return retn.value

    def ReadMemory64_byte(self,addr, size=1):
        addr = _ctypes.c_int(addr)
        retn = _ctypes.c_byte()
        BufferLength = _ctypes.c_int(size)
        self.ntdll.NtWow64ReadVirtualMemory64(int(self.hProcess), addr, _ctypes.byref(retn), BufferLength, 0)
        return retn.value

    def ReadMemory64_Wchar(self, addr, n, length):
        addr = _ctypes.c_ulonglong(addr)
        retn = _ctypes.c_wchar_p("0" * length)
        BufferLength = _ctypes.c_ulonglong(n)
        self.ntdll.NtWow64ReadVirtualMemory64(int(self.hProcess), addr, retn, BufferLength, 0)
        return retn.value

    def WriteMemory64(self, addr, var, size=4):
        addr = _ctypes.c_ulonglong(addr)
        retn = _ctypes.c_ulonglong(var)
        BufferLength = _ctypes.c_ulonglong(size)
        self.ntdll.NtWow64WriteVirtualMemory64(int(self.hProcess), addr, _ctypes.byref(retn), BufferLength, 0)

    def WriteMemory64_float(self, addr, var, size=4):
        addr = _ctypes.c_ulonglong(addr)
        retn = _ctypes.c_float(var)
        BufferLength = _ctypes.c_ulonglong(size)
        self.ntdll.NtWow64WriteVirtualMemory64(int(self.hProcess), addr, _ctypes.byref(retn), BufferLength, 0)

    def WriteMemory64_double(self, addr,var, size=8):
        addr = _ctypes.c_ulonglong(addr)
        retn = _ctypes.c_double(var)
        BufferLength = _ctypes.c_ulonglong(size)
        self.ntdll.NtWow64WriteVirtualMemory64(int(self.hProcess), addr, _ctypes.byref(retn), BufferLength, 0)

    def WriteMemory64_byte(self,addr,var, size=1):
        addr = _ctypes.c_ulonglong(addr)
        retn = _ctypes.c_byte(var)
        BufferLength = _ctypes.c_ulonglong(size)
        self.ntdll.NtWow64WriteVirtualMemory64(int(self.hProcess), addr, _ctypes.byref(retn), BufferLength, 0)

    def GetBaseAddr64(self, ModuleName):
        '''
        :func: 用于取64位应用程序模块地址
        :param ModuleName: 模块名称 如: dll、exe
        :return: 十六进制 整数
        '''
        NumberOfBytesRead = _ctypes.c_ulong()
        Buffer = PROCESS_BASIC_INFORMATION()
        Size = _ctypes.c_ulong(48)
        name_len = len(ModuleName)
        self.ntdll.NtWow64QueryInformationProcess64(int(self.hProcess), 0, _ctypes.byref(Buffer), Size,_ctypes.byref(NumberOfBytesRead))
        ret = self.ReadMemory64(Buffer.PebBaseAddress + 24, 8)
        ret = self.ReadMemory64(ret + 24, 8)
        for i in range(100000):
            modulehandle = self.ReadMemory64(ret + 48, 8)
            if modulehandle == 0:
                break
            nameaddr = self.ReadMemory64(ret + 96, 8)
            name = self.ReadMemory64_Wchar(nameaddr, name_len * 2 + 1, name_len)
            if name == ModuleName:
                return modulehandle
            ret = self.ReadMemory64(ret + 8, 8)